package io.tswf.minecraft.blockventure.core.expansion

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.expansion.annotations.Expand
import net.minecraft.recipe.Ingredient

@Expand(targetClasses = [ Ingredient ])
@CompileStatic
class ExpansionRecipeIngredient implements IMetadataSensitiveIngredient {
    boolean metadataSensitive

    boolean getMetadataSensitive() {
        return metadataSensitive
    }

    @Override
    boolean isMetadataSensitive() {
        return false
    }

    void setMetadataSensitive(boolean metadataSensitive) {
        this.metadataSensitive = metadataSensitive
    }
}

interface IMetadataSensitiveIngredient {
    boolean isMetadataSensitive()
    void setMetadataSensitive(boolean metadataSensitive)
}