package io.tswf.minecraft.blockventure.core.transmutation

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.*
import io.tswf.groovy.bettergroovy.asm.transmutation.meta.MissingTargetStrategy
import net.minecraftforge.registries.ForgeRegistry

@CompileStatic
class TransmutationLockedRegistries {

    @Transmute(
            targetClass = @ClassReference(descriptor = "Lnet/minecraftforge/registries/NamespacedWrapper;"),
            targetMethod = @MethodDescription(name = "lock", descriptor = "()V"),
            onMissing = MissingTargetStrategy.THROW
    )
    @AtHead
    @ReturningVoidIfTrue
    static boolean blockWrapperLock() {
        return true
    }

    @Transmute(
            targetClass = @ClassReference(ForgeRegistry),
            targetMethod = @MethodDescription(name = "isLocked", descriptor = "()Z"),
            onMissing = MissingTargetStrategy.THROW
    )
    @AtHead
    @ReturningConstantIfTrue(@Constant(booleanValue = false))
    static boolean passForgeRegistryLock() {
        return true
    }
}
